###############################
# Setup
###############################

###############################
# Include the template scripts
###############################

variables:
  PROJECT: ${MODULE}-test
  DEPENDENCIES: ${MODULE}
  VERSION: "1.0"
  MAINTAINER: "dune-archiso@gitlab.com"

include:
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module.repo.yaml"
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/build.yml"
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/load.yml"
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/pages.yml"

###############################
# Build from local PKGBUILD
###############################

build_dune-alugrid:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-alugrid"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x

###############################
# Build from local PKGBUILD
###############################

build_dune-codegen:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  allow_failure: true
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-codegen"
    DEPENDENCIES_PACKAGE: "dune-alugrid-${DUNE_VERSION}-*.pkg.tar.zst"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n[dune-extensions]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-extensions/$arch\n[dune-quality]\nSigLevel = Optional TrustAll\nServer = https://dune-archiso.gitlab.io/repository/dune-quality/$arch\n[dune-pdelab]\nSigLevel = Optional TrustAll\nServer = https://dune-archiso.gitlab.io/repository/dune-pdelab/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x
  needs: ["build_dune-alugrid"]

###############################
# Build from local PKGBUILD
###############################

build_dune-foamgrid:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-foamgrid"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x

###############################
# Build from local PKGBUILD
###############################

build_dune-grid-glue:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-grid-glue"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x

###############################
# Build from local PKGBUILD
###############################

build_dune-multidomaingrid:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-multidomaingrid"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x

###############################
# Build from local PKGBUILD
###############################

build_dune-polygongrid:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-polygongrid"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n' | sudo tee -a /etc/pacman.conf
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x

###############################
# Build from local PKGBUILD
###############################

build_dune-spgrid:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-spgrid"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x

#################################
# Build from local PKGBUILD
#################################

build_python-tpmc:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "python-tpmc"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n' | sudo tee -a /etc/pacman.conf

###############################
# Build from local PKGBUILD
###############################

build_dune-tpmc:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: start
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-tpmc"
    ISDUNEOPTS: "true"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "python-tpmc-*.pkg.tar.zst dune-alugrid-${DUNE_VERSION}-*.pkg.tar.zst"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x
  needs: ["build_python-tpmc", "build_dune-alugrid"]

###############################
# Build from local PKGBUILD
###############################

# build_dune-vcfv:
#   extends: .build_aur_template
#   tags: [saas-linux-large-amd64]
#   stage: .pre
#   variables:
#   ISARCH4EDU: "true"
#     ISAUR: "false"
#     MODULE: "dune-vcfv"
#     ISDUNEOPTS: "true"
#   before_script:
#     - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n' | sudo tee -a /etc/pacman.conf
#   after_script:
#     - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x

###############################
# Build from local PKGBUILD
###############################

build_dune-vectorclass:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-vectorclass"
    DUNE_VERSION: "2.6"
  before_script:
    - echo -e '\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x

###############################
# Build from local PKGBUILD
###############################

build_dune-vtk:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: start
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-vtk"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "dune-foamgrid-2.9.1-*.pkg.tar.zst"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x
  needs: ["build_dune-foamgrid"]

###############################
# Build from local PKGBUILD
###############################

build_dune-extensions:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: meta
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-extensions"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "dune-alugrid-${DUNE_VERSION}-*.pkg.tar.zst dune-multidomaingrid-2.8.0-*.pkg.tar.zst dune-spgrid-2.9.0-*.pkg.tar.zst dune-foamgrid-2.9.1-*.pkg.tar.zst dune-polygongrid-2.9.0-*.pkg.tar.zst dune-grid-glue-2.9.0-*.pkg.tar.zst dune-vectorclass-2.6-*.pkg.tar.zst python-tpmc-*.pkg.tar.zst dune-tpmc-2.6-*.pkg.tar.zst dune-vtk-2.9.0-*.pkg.tar.zst"
    # dune-codegen-2.8-*.pkg.tar.zst
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n' | sudo tee -a /etc/pacman.conf
  needs: [
      "build_dune-alugrid",
      # "build_dune-codegen",
      "build_dune-foamgrid",
      "build_dune-grid-glue",
      "build_dune-multidomaingrid",
      "build_dune-polygongrid",
      "build_dune-spgrid",
      "build_python-tpmc",
      "build_dune-tpmc",
      # "build_dune-vcfv",
      "build_dune-vectorclass",
      "build_dune-vtk",
    ]

###############################
# Create custom repository
###############################

load_repository_dune_extensions_modules:
  extends: .load_repository_template
  tags: [saas-linux-large-amd64]
  stage: load_repository
  dependencies: [
      "build_dune-alugrid",
      # "build_dune-codegen",
      "build_dune-foamgrid",
      "build_dune-grid-glue",
      "build_dune-multidomaingrid",
      "build_dune-polygongrid",
      "build_dune-spgrid",
      "build_python-tpmc",
      "build_dune-tpmc",
      # "build_dune-vcfv",
      "build_dune-vectorclass",
      "build_dune-vtk",
      "build_dune-extensions",
    ]

###############################
# Upload to GitLab repo (pages)
###############################

pages:
  extends: .pages_template
  tags: [saas-linux-large-amd64]
  stage: deploy
  variables:
    TARGET_FOLDER: "x86_64"
  needs: ["load_repository_dune_extensions_modules"]
